



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mysql数据库的test类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mysql数据库的test类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-07 21:17:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>文章参考自</p>
<p>window系统参考：<a href="http://blog.sina.com.cn/s/blog_46f7bb6d0102vde3.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_46f7bb6d0102vde3.html</a></p>
<p>linux 参考：<a href="http://www.linuxeye.com/database/2909.html" rel="external nofollow noreferrer">http://www.linuxeye.com/database/2909.html</a></p>
<h1>背景</h1>
<p>公司的数据库规范是，每个字段必须not null 且 必须有默认值</p>
<h1>问题</h1>
<p>设置为test类型后，字段不能设置默认值</p>
<h1>解决（不建议取消）</h1>
<p>取消数据库的严格模式</p>
<p>*********windows下**********</p>
<p>1、 找到mysql安装根目录下的my.ini文件</p>
<p>2、 找到这样一行：</p>
<p>sql-mode="STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"</p>
<p>3、 在其前面加&lsquo;#&rsquo;将其注释掉：</p>
<p>#sql-mode="STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"</p>
<p>4、 重启mysql服务</p>
<p>5、 重新执行你的mysql语句<br />*************linux下*************</p>
<p>方法一、</p>
<p>1）修改my.cnf1、设置启动参数，将默认sql_mode改为宽松模式使用命令：</p>
<div>
<pre class="prettyprint linenums">echo "sql-mode=NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION" &gt;&gt; /etc/my.cnf</pre>
</div>
<div>或手动修改：</div>
<div>vi /etc/my.cnf</div>
<div>找到sql-mode关键字，若没有，在文件尾添加一行</div>
<div>替换成：</div>
<div>sql-mode=NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTIO</div>
<div>2）重启mysql</div>
<div>
<pre class="prettyprint linenums">service mysqld restart</pre>
</div>
<p>方法二、修改启动脚本</p>
<p>1)设置启动脚本参数 使用命令：</p>
<div>
<div>
<pre class="prettyprint linenums">sed -i "s#\"\$\*\"#--sql-mode=\"NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION\"#" /etc/init.d/mysqld</pre>
</div>
<p>或手动修改： vi /etc/init.d/mysqld 找到 other_args="$*"</p>
<p>改成 other_args="--sql-mode=NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION"</p>
<div>2）重启mysql</div>
<div>
<pre class="prettyprint linenums">service mysqld restart</pre>
</div>
</div>
<h1>原因</h1>
<p>1、 MYSQL5.x是不允许BLOB/TEXT类型的字段拥有默认值的。</p>
<p>2、 由于MYSQL是在&lsquo;strict mode&rsquo;严格模式下工作的，如果改为非严格模式，即可</p>
<p>3、 MYSQL5.x在windows下是默认以&lsquo;strict mode&rsquo;工作的，当执行上面的语句时，会给你一个错误或者警告信息</p>
<p>但是严格模式为什么不能设置默认值的真正原因还不知道</p>
<h1>拓展</h1>
<p>1、何为严格模式&nbsp;&nbsp;http://koda.iteye.com/blog/288882</p>
<p>I. Strict Mode阐述&nbsp;<br />根据 mysql5.0以上版本 strict mode (STRICT_TRANS_TABLES) 的限制：&nbsp;<br />1).不支持对not null字段插入null值&nbsp;<br />2).不支持对自增长字段插入''值，可插入null值&nbsp;<br />3).不支持 text 字段有默认值</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r4y3d8.html">HTTP请求报文格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q220poq.html">特性Atrribute和枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g0007q.html">sublime-text3配置编译php</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6wgyq.html">CSS3实现32种基本图形</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prd24q.html">css圆环百分比</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5lgn8.html">C&sol;C&plus;&plus;预处理和编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/96od5ny9.html">cocos2d-x 不能在android真机debug的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmrz5e9.html">C&plus;&plus;通过OCCI操作Oracle数据库详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1do71q.html">Linux 安全模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vx4e8.html">CentOS下安装XAMPP详细教程（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey6kpm9.html">python虚拟环境--virtualenv</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmv51q.html">在django中uwsgi的使用，以及安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv14mgxq.html">马昕璐 201771010118《面向对象程序设计（java）》第十五周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rjd7j9.html">CentOS7用阿里云Docker Yum源在线安装Docker 17&period;03&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxrwz9.html">Install Jetty web server on CentOS 7 &sol; RHEL 7</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmjv6w9.html">go语言之行--接口&lpar;interface&rpar;、反射&lpar;reflect&rpar;详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kx47xq.html">docker daemon configuration</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd14vg8.html">WPF绘制简单常用的Path（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jezj048.html">windows共享连接显示无法打开</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x5mdl9.html">如何自定义修改ztree树节点的图标</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90r1p1o9.html">阿里CentOS 7 卸载mysql5&period;6</a>
			</li>
						<li><a href="https://www.batexi.com/a/9604dwy9.html">请输入经过encode编码的URL</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4xr2z9.html">python之黏包和黏包解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2734y9.html">NODE获取节点删除空格的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ojj6x8.html">Jenkins&amp;&num;160&semi;解决Jenkins下java无法运行slave-agent&amp;&num;160&semi;jnlp程序连接Windows&amp;&num;160&semi;Slave主机</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rdd048.html">JMeter&amp;&num;160&semi;集合点设置之Synchronizing&amp;&num;160&semi;Timer的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oj31k8.html">Java并发编程（七）深入剖析ThreadLocal</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvl0zg8.html">MVP模式及性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvl07k8.html">Collections工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjdlmj9.html">&lpar;小技巧&rpar;Sql server查看sql语句的执行时间&lpar;转&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
